const OFFICIAL = {
  // 2XX
  HTTP_OK: 200,
  HTTP_CREATED: 201,
  HTTP_ACCEPTED: 202,
  HTTP_NON_AUTHORITATIVE_INFORMATION: 203,
  HTTP_NO_CONTENT: 204,
  HTTP_RESET_CONTENT: 205,
  HTTP_PARTIAL_CONTENT: 206,
  HTTP_MULTI_STATUS: 207,
  HTTP_ALREADY_REPORTED: 208,
  HTTP_IM_USED: 226,

  // 3XX
  HTTP_MULTIPLE_CHOICE: 300,
  HTTP_MOVED_PERMANENTLY: 301,
  HTTP_FOUND: 302,
  HTTP_SEE_OTHER: 303,
  HTTP_NOT_MODIFIED: 304,
  HTTP_USE_PROXY: 305,
  HTTP_UNUSED: 306,
  HTTP_TEMPORARY_REDIRECT: 307,
  HTTP_PERMANENT_REDIRECT: 308,

  // 4XX
  HTTP_BAD_REQUEST: 400,
  HTTP_UNAUTHORIZED: 401,
  HTTP_PAYMENT_REQUIRED: 402,
  HTTP_FORBIDDEN: 403,
  HTTP_NOT_FOUND: 404,
  HTTP_METHOD_NOT_ALLOWED: 405,
  HTTP_NOT_ACCEPTABLE: 406,
  HTTP_PROXY_AUTHENTICATION_REQUIRED: 407,
  HTTP_REQUEST_TIMEOUT: 408,
  HTTP_CONFILCT: 409,
  // 41X
  HTTP_GONE: 410,
  HTTP_LENGTH_REQUIRED: 411,
  HTTP_PRECONDITION_FAILED: 412,
  HTTP_PAYLOAD_TOO_LARGE: 413,
  HTTP_URI_TOO_LONG: 414,
  HTTP_UNSUPPORTED_MEDIA_TYPE: 415,
  HTTP_RANGE_NOT_SATISFIABLE: 416,
  HTTP_EXPECTATION_FAILED: 417,
  HTTP_I_AM_A_TEAPOT: 418, // WHOEVER MADE THIS IS A FUNNY GUY (RESPECT)
  // 42X
  HTTP_MISDIRECTED_REQUEST: 421,
  HTTP_UNPROCESSABLE_ENTRY: 422,
  HTTP_LOCKED: 423,
  HTTP_FAILED_DEPENDENCY: 424,
  HTTP_TOO_EARLY: 425,
  HTTP_UPGRADE_REQUIRED: 426,

  HTTP_PRECONDITION_REQUIRED: 428,
  HTTP_TOO_MANY_REQUEST: 429,
  HTTP_REQUEST_HEADER_FIELDS_TOO_LARGE: 431,
  HTTP_UNAVAILABLE_FOR_LEGAL_REASONS: 451,

  // 5XX
  HTTP_INTERNAL_SERVER_ERROR: 500,
  HTTP_NOT_IMPLEMENTED: 501,
  HTTP_BAD_GETEWAY: 502,
  HTTP_SERVICE_UNAVAILABLE: 503,
  HTTP_GATEWAY_TIMEOUT: 504,
  HTTP_HTTP_VERSION_NOT_SUPPORTED: 505,
  HTTP_VARIANT_ALSO_NEGOTIATES: 506,
  HTTP_INSUFFICIENT_STORAGE: 507,
  HTTP_LOOP_DETECTED: 508,
  HTTP_NOT_EXTENDED: 510,
  HTTP_NETWORK_AUTHENTICATION_REQUIRED: 511,
};

/*
 * UNOFFICIAL STATUS CODES
 */
const UNOFFICIAL = {
  HTTP_THIS_IS_FINE: 218,
  HTTP_PAGE_EXPIRED: 419,
  // HTTP_METHOD_FAILED: 420, // DEPRECAATED BY SPRING FRAMEWORK
  HTTP_ENHANCE_YOUR_CALM: 420, //
  HTTP_U_REQUEST_HEADER_FIELDS_TOO_LARGE: 430, // SHOPIFY
  HTTP_BLOCKED_BY_WINDOWS_PARENTAL_CONTROLS: 450, // MICROSOFT
  HTTP_INVALID_TOKEN: 498, // Esri
  HTTP_TOKEN_REQUIRED: 499,
  HTTP_BANDWIDTH_LIMIT_EXCEEDED: 509, // APACHE
  HTTP_INVALID_SSL_CERTIFICATE: 526, //CLOUDFLARE
  HTTP_SITE_IS_OVERLOADED: 529,
  HTTP_SITE_IS_FROZEN: 530,
  HTTP_NETWORK_READ_TIMEOUT_ERROR: 598,
};

/*
 * INTERNET INFORMATION SERVICE
 */
const INTERNET_INFORMATION_SERVICE = {
  HTTP_LOGIN_TIME_OUT: 440,
  HTTP_RETRY_WITH: 449,
  HTTP_REDIRECT: 451,
};

/*
 * NGINX
 */
const NGINX = {
  HTTP_NO_RESPONSE: 444,
  HTTP_REQUEST_HEADER_TOO_LARGE: 494,
  HTTP_SSL_CERTIFICATE_ERROR: 495,
  HTTP_SSL_CERTIFICATE_REQUIRED: 496,
  HTTP_REQUEST_SENT_TO_HTTPS_PORT: 497,
  HTTP_CLIENT_CLOSED_REQUEST: 499,
};

/*
 * CLOUDFLARE
 */
const CLOUDFLARE = {
  HTTP_WEB_SERVER_RETURNED_AN_UNKNOWN_ERROR: 520,
  HTTP_WEB_SERVER_IS_DOWN: 521,
  HTTP_CONNECTION_TIMED__OUT: 522,
  HTTP_ORIGIN_IS_UNREACHABLE: 523,
  HTTP_A_TIMEOUT_OCCURRED: 524,
  HTTP_SSL_HANDSHAKE_FAILED: 525,
  HTTP_INVALID_SSL_CERTIFICATE: 526,
  HTTP_RAILGUN_ERROR: 527,
  HTTP_NOT_LOGGED_IN: 530,
};

const STATUS = Object.freeze({
  OFFICIAL: Object.freeze(OFFICIAL),
  UNOFFICIAL: Object.freeze(UNOFFICIAL),
  INTERNET_INFORMATION_SERVICE: Object.freeze(INTERNET_INFORMATION_SERVICE),
  NGINX: Object.freeze(NGINX),
  CLOUDFLARE: Object.freeze(CLOUDFLARE),
});

module.exports = STATUS;

/*
 * AWS ELASTIC LOAD BALANCER
 */
/*
module.exports = {
  HTTP_CLIENT_CLOSED_CONNECTION: 460,
  HTTP_FORWARDED: 463,
  HTTP_UNAUTHORIZED: 561,
};
*/
